-------------------------------------------------------------

-- Elctric ALTIMETER collins
-- Version 1.1 Jacques Zahar 08/17

-- version 2.x
-- Based on JL PERROT work
-------------------------------------------------------------
-------------------------------------
-- customization section
-------------------------------------
display_bezel=true 
display_screws=true
-------------------------------------
local baro_set = 0
local flag=false
local cur_alt=0
local startvalue=0
local targetvalue=0
local endvalue=0
local increment=0
local initialvalue=0
local rotvalue=0
local testmode=false
local flag_on=true
local y_value=-100
local battery_on=false
img_add_fullscreen( "Altimeterbkg.png" )
--img_add("Altimeterbkg.png",-125,-120,640,640 )
roll_alt10000	= img_add( "alt_roll_10000.png", 171, -742, 70, 1077 )--147, -300-144, 70, 1077 )
roll_alt1000	= img_add( "alt_roll_0-9.png", 255, -742, 51, 1077 )
roll_alt100		= img_add( "alt_roll_0-9.png", 333,-742, 51, 1077 )--341
roll_alt10		= img_add( "alt_roll_10.png", 378, -742, 100, 1077 )

viewport_rect( roll_alt10000 , 150, 187, 125, 105 )
viewport_rect( roll_alt1000	, 225, 187, 125, 105)
viewport_rect( roll_alt100, 320, 165, 100, 145)
viewport_rect( roll_alt10, 375, 165, 125, 145 )

roll_hpa1 = img_add( "alt_roll_mini.png", 230, -300, 24, 616)---98-40,308+77)
roll_hpa2 = img_add( "alt_roll_mini.png", 278, -300, 24, 616)
roll_hpa3 = img_add( "alt_roll_mini.png", 340, -300, 24, 616)
roll_hpa4 = img_add( "alt_roll_mini.png", 390, -300, 24, 616)

viewport_rect( roll_hpa1, 225, 340,125, 70 )
viewport_rect( roll_hpa2, 256, 340,125, 69 )
viewport_rect( roll_hpa3, 320, 340,125, 70 )
viewport_rect( roll_hpa4, 376, 340,125, 70 )

roll_inhg1 = img_add( "alt_roll_mini.png", 230, -205+130, 24, 616)
roll_inhg2 = img_add( "alt_roll_mini.png", 278, -205+130, 24, 616)
roll_inhg3 = img_add( "alt_roll_mini.png", 340, -205+130, 24, 616)
roll_inhg4 = img_add( "alt_roll_mini.png",390,-205+130, 24, 616)

viewport_rect( roll_inhg1, 205, 418, 125, 66 )
viewport_rect( roll_inhg2, 260, 418, 125, 66 )
viewport_rect( roll_inhg3, 335, 418, 125, 66 )
viewport_rect( roll_inhg4, 385, 418, 125, 66 )



img_flag=img_add_fullscreen("flag.png")--,82,125,150,30)
img_move(img_flag,0,-100,nil,nil)


img_add_fullscreen( "Altimeter.png" )
img_volethg=img_add_fullscreen("volet.png")
img_voletmb=img_add_fullscreen("volet2.png")
img_needle = img_add_fullscreen("aiguille.png")
img_add_fullscreen("aiguillecenter.png")
img_add_fullscreen("TestKnobAltimeter.png")
if display_bezel==true then
	img_add_fullscreen("Altimeterbezel.png")
end
if display_screws==true then 
screw1=img_add("screw.png",10,10,40,40)
img_rotate(screw1,25)
screw2=	img_add("screw.png",588,10,40,40)
img_rotate(screw2,55)
screw3=	img_add("screw.png",10,570,40,40)
img_rotate(screw3,-25)
screw4=	img_add("screw.png",588,570,40,40)
img_rotate(screw4,85)
end


hgmode=true
visible(img_voletmb,hgmode)
visible(img_volethg,not(hgmode))
temp_sea = 15.00
--visible(img_flag,flag)


function baro_dial(dir)

	if dir == 1 then --and pressure < 31.00 then
		baro_set = baro_set + 0.01
		xpl_dataref_write("sim/cockpit/misc/barometer_setting", "FLOAT", baro_set)
		fsx_event("KOHLSMAN_INC")
	elseif dir == -1 then --and pressure > 26.00 then
		baro_set = baro_set - 0.01
		xpl_dataref_write("sim/cockpit/misc/barometer_setting", "FLOAT", baro_set)
		fsx_event("KOHLSMAN_DEC")
	end

end



function new_altimeter(altitude, baro_set, temp_sea, baro_sea, baro_cur)
if battery_on==true then    
	if(baro_set==0) then baro_set = 29.92 end
	if(baro_cur==0) then baro_cur = 29.92 end

	temp_K = 273.15 + temp_sea
	--Alt = (287 x (Temp C° + 273,15)/9,81) x ln(QNH/P)
 -- altitude_meter = (temp_K * 287 / 9.81) * math.log(baro_set/baro_cur)
 -- altitude = (altitude_meter * 3.2808399)    

    img_rotate(img_needle, (altitude - math.floor(altitude/10000)*10000 )*0.361)
    cur_alt=altitude
	-- alt roll
	alt = string.format("%05d",altitude)
	move( roll_alt10000	, nil, -726 - string.sub(alt,1,1)	* 77.5 *-1, nil, nil )-- -682
	move( roll_alt1000	, nil, -728 - string.sub(alt,2,2)* 77.5 *-1, nil, nil )
	move( roll_alt100	, nil, -726 - string.sub(alt,3,3)* 77.5 *-1, nil, nil )
	move( roll_alt10	, nil, -726 - string.sub(alt,4,5)/10* 76.8 *-1, nil, nil )
end	
--baro roll	
	inhg = string.format("%04d",baro_set *100)
	move( roll_inhg1, nil, -102 - string.sub( inhg, 1, 1 ) * 44 *-1, nil, nil )
	move( roll_inhg2, nil, -102 - string.sub( inhg, 2, 2 ) * 44 *-1, nil, nil )
	move( roll_inhg3, nil, -102 - string.sub( inhg, 3, 3 ) * 44 *-1, nil, nil )
	move( roll_inhg4, nil, -102 - string.sub( inhg, 4, 4 ) * 44 *-1, nil, nil )
	
	hpa = string.format( "%04d", baro_set * 33.8639 )
	move( roll_hpa1, nil, -170 - string.sub( hpa, 1, 1 ) * 44 *-1, nil, nil )
	move( roll_hpa2, nil, -170- string.sub( hpa, 2, 2 ) * 44 *-1, nil, nil )
	move( roll_hpa3, nil, -170 - string.sub( hpa, 3, 3 ) * 44 *-1, nil, nil )
	move( roll_hpa4, nil, -170 - string.sub( hpa, 4, 4 ) * 44 *-1, nil, nil )

end

function callback_std_mode()
		baro_set=29.92
		xpl_dataref_write("sim/cockpit/misc/barometer_setting", "FLOAT", baro_set)
		fsx_variable_write("Kohlsman setting hg","inHg ",29.92)
		--baro roll	
	inhg = string.format("%04d",baro_set *100)
	move( roll_inhg1, nil, -102 - string.sub( inhg, 1, 1 ) * 44 *-1, nil, nil )
	move( roll_inhg2, nil, -102 - string.sub( inhg, 2, 2 ) * 44 *-1, nil, nil )
	move( roll_inhg3, nil, -102 - string.sub( inhg, 3, 3 ) * 44 *-1, nil, nil )
	move( roll_inhg4, nil, -102 - string.sub( inhg, 4, 4 ) * 44 *-1, nil, nil )
	
	hpa = string.format( "%04d", baro_set * 33.8639 )
	move( roll_hpa1, nil, -170 - string.sub( hpa, 1, 1 ) * 44 *-1, nil, nil )
	move( roll_hpa2, nil, -170- string.sub( hpa, 2, 2 ) * 44 *-1, nil, nil )
	move( roll_hpa3, nil, -170 - string.sub( hpa, 3, 3 ) * 44 *-1, nil, nil )
	move( roll_hpa4, nil, -170 - string.sub( hpa, 4, 4 ) * 44 *-1, nil, nil )

end

img_baro = dial_add("alt_button.png", 500, 480, 100, 100, baro_dial)
dial_click_rotate(img_baro, 20)


function callback_act_mode()
hgmode=not(hgmode)
visible(img_voletmb,hgmode)
visible(img_volethg,not(hgmode))
end

btn_alt = button_add("alt_button_pull.png","alt_button_push.png",520,500,100,100,callback_act_mode)

function needle_move()
if battery_on==true then 
	--if startvalue>1000 or startvalue<0 then startvalue=0 end
 if testmode==true then
	--if targetvalue==270 or targetvalue==-90 then 
	testvalue=var_round(rotvalue/10,0)*10 --else testvalue=rotvalue end
	if testvalue==var_round(targetvalue/10,0)*10 then 
	--increment=0
	img_rotate(img_needle,targetvalue)
	--rotvalue=targetvalue
    testmode=false
	else

	--if rotvalue<0 then rotvalue=360 end
	
--	print(var_round(rotvalue/10,0)*10,"s",rotvalue,"e",targetvalue,"step",increment)

	rotvalue=rotvalue+increment
	img_rotate(img_needle,rotvalue)
	end
	end
 end	
	
end

function needle_rotate(startvalue,endvalue)
 targetvalue=endvalue
 rotvalue=startvalue
end

function callback_tst_mode_pressed()
if battery_on==true then 
testmode=true
	startvalue=math.floor(cur_alt - math.floor(cur_alt/10000)*10000 )
	initialvalue=startvalue%1000*0.36
--	print("cur",cur_alt)
--	print("start",startvalue)
--	print("initial",initialvalue)
	increment=0
	if initialvalue>90 and initialvalue<270 then
	increment=10
	needle_rotate(initialvalue,270)
	end
	if initialvalue<=90 and initialvalue>=-90 then 
	increment=-10 
	needle_rotate(initialvalue,-90)
	end
	if initialvalue<=360 and initialvalue>=270 then 
	increment=-10 
	needle_rotate(initialvalue,270)
	end
   flag_on=true
end
end

function flag_move()

if flag_on==true then 
--print("flag ON")
   if y_value>=0 then 
		-- y_value=nil 
		-- inc=0
   else 
      inc=10
   --visible(img_flag,true)
   y_value=y_value+inc
   img_move(img_flag,0,y_value,nil,nil)
   end
else
--print("flag OFF")
   if y_value<=-80 then 
			y_value=-80
			inc=0
			--visible(img_flag,false)
		else
		   inc=-10
			y_value=y_value+inc
			img_move(img_flag,0,y_value,nil,nil)
		end
end
--print(y_value)

end

function callback_tst_mode_released()
if battery_on==true then 
testmode=true
	   -- (cur_alt - math.floor(cur_alt/10000)*10000 )*0.36)
	   --startvalue=750--cur_alt - math.floor(cur_alt/10000)*10000
	   
	-- if startvalue%1000>750 or startvalue%1000<250 then
	-- increment=10
	-- else 
	-- increment=-10
	-- end	   
       -- needle_rotate(initialvalue) --cur_alt - math.floor(cur_alt/10000)*10000 )
	   
	increment=-increment
		-- print("cur",cur_alt)
	-- print("rstart",rotvalue)
	-- print("rinitial",initialvalue)
	-- print("increment",increment)
	--if initialvalue>90 and initialvalue<270 then
	-- increment=-10
	-- needle_rotate(rotvalue,initialvalue)
	-- end
	-- if initialvalue<=90 and initialvalue>=-90 then 
	-- increment=-10 
	-- needle_rotate(rotvalue,initialvalue)
	-- end
	-- if initialvalue<=360 and initialvalue>=270 then 
	-- increment=10 
	-- needle_rotate(rotvalue,initialvalue)
	-- end
	--needle_rotate(rotvalue,initialvalue)
	--end
	-- if initialvalue<=90 and initialvalue>=-90 then 
	-- increment=-10 
	-- needle_rotate(startvalue)
	-- end
	-- if initialvalue<=360 and initialvalue>=270 then 
	-- increment=-10 
	-- needle_rotate(startvalue)
	-- end
	needle_rotate(rotvalue,initialvalue)--var_round(initialvalue/10,0)*10)
    --img_rotate(img_needle,initialvalue)
	--startvalue=initialvalue
flag_on=false
	--testmode=false
end
end

function battery_state(batt)

	if batt==1 then 
		flag_on=false
		battery_on=true
	else
		flag_on=true
		testmode=true
		battery_on=false
	end
end

function battery_state_fsx(batt)
	battery_state(fif(batt,1,0))
end

btn_tst = button_add("test_button_off.png","test_button_on.png",100,510,35,35,callback_tst_mode_pressed,callback_tst_mode_released)


	
xpl_dataref_subscribe("sim/cockpit2/gauges/indicators/altitude_ft_pilot", "FLOAT",
					  "sim/cockpit/misc/barometer_setting", "FLOAT", 
					  "sim/weather/temperature_sealevel_c", "FLOAT", 
					  "sim/weather/barometer_sealevel_inhg", "FLOAT",
					  "sim/weather/barometer_current_inhg", "FLOAT", new_altimeter)

					  xpl_dataref_subscribe("sim/cockpit/electrical/battery_on","INT",battery_state)

fsx_variable_subscribe("ELECTRICAL MASTER BATTERY","Boolean",battery_state_fsx)

fsx_variable_subscribe("Indicated Altitude", "feet",
					   "Kohlsman setting hg", "inHg",
					   "AMBIENT TEMPERATURE", "Celsius", 
					   "SEA LEVEL PRESSURE", "inHg", 
					   "BAROMETER PRESSURE", "inHg", new_altimeter)
timer_start(0,50,needle_move)
timer_start(0,40,flag_move)